<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="mtb__bmi160_8c" kind="file" language="C++">
    <compoundname>mtb_bmi160.c</compoundname>
    <includes local="yes" refid="mtb__bmi160_8h">mtb_bmi160.h</includes>
    <includes local="yes">cyhal_i2c.h</includes>
    <includes local="yes">cyhal_system.h</includes>
    <incdepgraph>
      <node id="1">
        <label>cyhal_i2c.h</label>
      </node>
      <node id="0">
        <label>mtb_bmi160.c</label>
        <link refid="mtb__bmi160_8c" />
        <childnode refid="1" relation="include">
        </childnode>
        <childnode refid="2" relation="include">
        </childnode>
      </node>
      <node id="2">
        <label>cyhal_system.h</label>
      </node>
    </incdepgraph>
      <sectiondef kind="define">
      <memberdef id="mtb__bmi160_8c_1afa3215f0aa766367f5d34bee80929152" kind="define" prot="public" static="no">
        <name>I2C_TIMEOUT</name>
        <initializer>10 /* 10 msec */</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="34" column="9" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="34" />
      </memberdef>
      <memberdef id="mtb__bmi160_8c_1adda91affa98309a2bc74abc7e632e907" kind="define" prot="public" static="no">
        <name>BMI160_ERROR</name>
        <param><defname>x</defname></param>
        <initializer>(CY_RSLT_CREATE(CY_RSLT_TYPE_ERROR, CY_RSLT_MODULE_BOARD_HARDWARE_BMI160, x))</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="35" column="9" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="35" />
      </memberdef>
      <memberdef id="mtb__bmi160_8c_1a2a7890ea95c966d65d07d92c5981b3c5" kind="define" prot="public" static="no">
        <name>I2C_WRITE_BUFFER_LENGTH</name>
        <initializer>32</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="36" column="9" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="36" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="var">
      <memberdef id="mtb__bmi160_8c_1a297e075e8df0f081f9a9db14ca4d5016" kind="variable" mutable="no" prot="public" static="yes">
        <type>cyhal_i2c_t *</type>
        <definition>cyhal_i2c_t* i2c</definition>
        <argsstring />
        <name>i2c</name>
        <initializer>= NULL</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="38" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="38" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="mtb__bmi160_8c_1a083dda06de4cce5fee0d461f1c54262b" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>unsigned int</type>
        <definition>static unsigned int i2c_write_bytes</definition>
        <argsstring>(uint8_t dev_addr, uint8_t reg_addr, uint8_t *data, uint16_t len)</argsstring>
        <name>i2c_write_bytes</name>
        <param>
          <type>uint8_t</type>
          <declname>dev_addr</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>reg_addr</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>len</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="53" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="40" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="40" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__bmi160_8c_1a65e393517ace0e29070954f266d13e2b" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>unsigned int</type>
        <definition>static unsigned int i2c_read_bytes</definition>
        <argsstring>(uint8_t dev_addr, uint8_t reg_addr, uint8_t *data, uint16_t len)</argsstring>
        <name>i2c_read_bytes</name>
        <param>
          <type>uint8_t</type>
          <declname>dev_addr</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>reg_addr</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>len</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="63" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="55" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="55" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__bmi160_8c_1a14c2fc66515c8ed2058b9dbff81da887" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>void</type>
        <definition>static void delay_wrapper</definition>
        <argsstring>(uint32_t ms)</argsstring>
        <name>delay_wrapper</name>
        <param>
          <type>uint32_t</type>
          <declname>ms</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="68" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="65" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="65" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gac8f26d8dfa22eaef5a39303409133dfc" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t mtb_bmi160_init_i2c</definition>
        <argsstring>(mtb_bmi160_t *obj, cyhal_i2c_t *inst, mtb_bmi160_address_t address)</argsstring>
        <name>mtb_bmi160_init_i2c</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>cyhal_i2c_t *</type>
          <declname>inst</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__board__libs_1gaa1ef72a83807270481aaa556892729bd">mtb_bmi160_address_t</ref></type>
          <declname>address</declname>
        </param>
        <briefdescription>
<para>Initialize the IMU for I2C communication. </para>        </briefdescription>
        <detaileddescription>
<para>Then applies the default configuration settings for both the accelerometer &amp; gyroscope. Known maximum I2C frequency of 1MHz; refer to manufacturer's datasheet for confirmation. See: <ref kindref="member" refid="group__group__board__libs_1gae39ac49787bfd21ab9c2b1ebdfe03fd8">mtb_bmi160_config_default()</ref> <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BMI160 object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">inst</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C instance to use for communicating with the BMI160 sensor. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>BMI160 I2C address, set by hardware implemntation. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if properly initialized, else an error indicating what went wrong. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="90" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="70" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="70" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gae39ac49787bfd21ab9c2b1ebdfe03fd8" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t mtb_bmi160_config_default</definition>
        <argsstring>(mtb_bmi160_t *obj)</argsstring>
        <name>mtb_bmi160_config_default</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Configure the motion sensor to a default mode with both accelerometer &amp; gyroscope enabled with a nominal output data rate. </para>        </briefdescription>
        <detaileddescription>
<para>The default values used are from the example in the BMI160 driver repository, see <ulink url="https://github.com/BoschSensortec/BMI160_driver">https://github.com/BoschSensortec/BMI160_driver</ulink> <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BMI160 object. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if properly initialized, else an error indicating what went wrong. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="116" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="92" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="92" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga6e259c8f5f575e06fc3d35c525b4038f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t mtb_bmi160_read</definition>
        <argsstring>(mtb_bmi160_t *obj, mtb_bmi160_data_t *sensor_data)</argsstring>
        <name>mtb_bmi160_read</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structmtb__bmi160__data__t">mtb_bmi160_data_t</ref> *</type>
          <declname>sensor_data</declname>
        </param>
        <briefdescription>
<para>Reads the current accelerometer &amp; gyroscope data from the motion sensor. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BMI160 object. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">sensor_data</parametername>
</parameternamelist>
<parameterdescription>
<para>The accelerometer &amp; gyroscope data read from the motion sensor </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if properly initialized, else an error indicating what went wrong. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="127" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="118" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="118" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga5ea290e0ec118186d1c10b23edfaa98e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>struct bmi160_dev *</type>
        <definition>struct bmi160_dev* mtb_bmi160_get</definition>
        <argsstring>(mtb_bmi160_t *obj)</argsstring>
        <name>mtb_bmi160_get</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Gets access to the base motion sensor data. </para>        </briefdescription>
        <detaileddescription>
<para>This allows for direct manipulation of the sensor for any desired behavior. See <ulink url="https://github.com/BoschSensortec/BMI160_driver">https://github.com/BoschSensortec/BMI160_driver</ulink> for more details on the sensor. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BMI160 object. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>pointer to the BMI160 configuration structure. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="132" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="129" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="129" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gacf88df809c21de6db3fa1b24ba1044f2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t mtb_bmi160_selftest</definition>
        <argsstring>(mtb_bmi160_t *obj)</argsstring>
        <name>mtb_bmi160_selftest</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Performs both accelerometer and gyro self tests. </para>        </briefdescription>
        <detaileddescription>
<para>Note these tests cause a soft reset of the device and device should be reconfigured after a test. See <ulink url="https://github.com/BoschSensortec/BMI160_driver">https://github.com/BoschSensortec/BMI160_driver</ulink> for more details. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BMI160 object. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if self tests pass, else an error indicating what went wrong. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="146" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="134" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="134" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__bmi160_8c_1a0b69103fa637c109b056c504ec64da80" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t _mtb_bmi160_config_int</definition>
        <argsstring>(cyhal_gpio_t *intpin, cyhal_gpio_t pin, bool init, uint8_t intr_priority, cyhal_gpio_event_t event, cyhal_gpio_event_callback_t callback, void *callback_arg)</argsstring>
        <name>_mtb_bmi160_config_int</name>
        <param>
          <type>cyhal_gpio_t *</type>
          <declname>intpin</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>pin</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>init</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>intr_priority</declname>
        </param>
        <param>
          <type>cyhal_gpio_event_t</type>
          <declname>event</declname>
        </param>
        <param>
          <type>cyhal_gpio_event_callback_t</type>
          <declname>callback</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>callback_arg</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="172" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="148" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="148" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gae3faebe4fcb363ab41d2f79a297ddf66" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t mtb_bmi160_config_int</definition>
        <argsstring>(mtb_bmi160_t *obj, struct bmi160_int_settg *intsettings, cyhal_gpio_t pin, uint8_t intr_priority, cyhal_gpio_event_t event, cyhal_gpio_event_callback_t callback, void *callback_arg)</argsstring>
        <name>mtb_bmi160_config_int</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>struct bmi160_int_settg *</type>
          <declname>intsettings</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>pin</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>intr_priority</declname>
        </param>
        <param>
          <type>cyhal_gpio_event_t</type>
          <declname>event</declname>
        </param>
        <param>
          <type>cyhal_gpio_event_callback_t</type>
          <declname>callback</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>callback_arg</declname>
        </param>
        <briefdescription>
<para>Configure a GPIO pin as an interrupt for the BMI160. </para>        </briefdescription>
        <detaileddescription>
<para>This configures the pin as an interrupt, and calls the BMI160 interrupt configuration API with the application supplied settings structure. See <ulink url="https://github.com/BoschSensortec/BMI160_driver">https://github.com/BoschSensortec/BMI160_driver</ulink> for more details. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BMI160 object. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">intsettings</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BMI160 interrupt settings structure. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pin</parametername>
</parameternamelist>
<parameterdescription>
<para>Which pin to configure as interrupt </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">intr_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority for NVIC interrupt events </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">event</parametername>
</parameternamelist>
<parameterdescription>
<para>The type of interrupt event </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback</parametername>
</parameternamelist>
<parameterdescription>
<para>The function to call when the specified event happens. Pass NULL to unregister the handler. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback_arg</parametername>
</parameternamelist>
<parameterdescription>
<para>Generic argument that will be provided to the callback when called, can be NULL </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if interrupt was succesffuly enabled. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="206" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="174" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="174" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga8c47f76e2339fd3a4b50d7c8c1462003" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_bmi160_free</definition>
        <argsstring>(mtb_bmi160_t *obj)</argsstring>
        <name>mtb_bmi160_free</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Frees up any resources allocated by the motion_sensor as part of <ref kindref="member" refid="group__group__board__libs_1gac8f26d8dfa22eaef5a39303409133dfc">mtb_bmi160_init_i2c()</ref>. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BMI160 object. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="221" bodyfile="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" bodystart="208" column="1" file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" line="208" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Description: This file contains the functions for interacting with the motion sensor. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/**************************************************************************/</highlight></codeline>
<codeline lineno="25"><highlight class="preprocessor">#include<sp />"mtb_bmi160.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="26"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_i2c.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="27"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_system.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal">{</highlight></codeline>
<codeline lineno="32"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="33"><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal" /><highlight class="preprocessor">#define<sp />I2C_TIMEOUT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />10<sp /></highlight><highlight class="comment">/*<sp />10<sp />msec<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="35"><highlight class="normal" /><highlight class="preprocessor">#define<sp />BMI160_ERROR(x)<sp /><sp /><sp /><sp /><sp />(CY_RSLT_CREATE(CY_RSLT_TYPE_ERROR,<sp />CY_RSLT_MODULE_BOARD_HARDWARE_BMI160,<sp />x))</highlight><highlight class="normal" /></codeline>
<codeline lineno="36"><highlight class="normal" /><highlight class="preprocessor">#define<sp />I2C_WRITE_BUFFER_LENGTH<sp /><sp /><sp />32</highlight><highlight class="normal" /></codeline>
<codeline lineno="37"><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />cyhal_i2c_t<sp />*i2c<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="39"><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">unsigned</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />i2c_write_bytes(uint8_t<sp />dev_addr,<sp />uint8_t<sp />reg_addr,<sp />uint8_t<sp />*data,<sp />uint16_t<sp />len)</highlight></codeline>
<codeline lineno="41"><highlight class="normal">{</highlight></codeline>
<codeline lineno="42"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(len<sp />+<sp />1<sp />&lt;<sp />I2C_WRITE_BUFFER_LENGTH);</highlight></codeline>
<codeline lineno="43"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />buf[I2C_WRITE_BUFFER_LENGTH];</highlight></codeline>
<codeline lineno="44"><highlight class="normal"><sp /><sp /><sp /><sp />buf[0]<sp />=<sp />reg_addr;</highlight></codeline>
<codeline lineno="45"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(uint16_t<sp />i=0;<sp />i&lt;len;<sp />i++)</highlight></codeline>
<codeline lineno="46"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="47"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />buf[i+1]<sp />=<sp />data[i];</highlight></codeline>
<codeline lineno="48"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="49"><highlight class="normal" /></codeline>
<codeline lineno="50"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result<sp />=<sp />cyhal_i2c_master_write(i2c,<sp />dev_addr,<sp />buf,<sp />len+1,<sp />I2C_TIMEOUT,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="51"><highlight class="normal" /></codeline>
<codeline lineno="52"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="53"><highlight class="normal">}</highlight></codeline>
<codeline lineno="54"><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">unsigned</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />i2c_read_bytes(uint8_t<sp />dev_addr,<sp />uint8_t<sp />reg_addr,<sp />uint8_t<sp />*data,<sp />uint16_t<sp />len)</highlight></codeline>
<codeline lineno="56"><highlight class="normal">{</highlight></codeline>
<codeline lineno="57"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result<sp />=<sp />cyhal_i2c_master_write(i2c,<sp />dev_addr,<sp />&amp;reg_addr,<sp />1,<sp />I2C_TIMEOUT,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="58"><highlight class="normal" /></codeline>
<codeline lineno="59"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_RSLT_SUCCESS<sp />==<sp />result)</highlight></codeline>
<codeline lineno="60"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />cyhal_i2c_master_read(i2c,<sp />dev_addr,<sp />data,<sp />len,<sp />I2C_TIMEOUT,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="61"><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="63"><highlight class="normal">}</highlight></codeline>
<codeline lineno="64"><highlight class="normal" /></codeline>
<codeline lineno="65"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />delay_wrapper(uint32_t<sp />ms)</highlight></codeline>
<codeline lineno="66"><highlight class="normal">{</highlight></codeline>
<codeline lineno="67"><highlight class="normal"><sp /><sp /><sp /><sp />(void)cyhal_system_delay_ms(ms);</highlight></codeline>
<codeline lineno="68"><highlight class="normal">}</highlight></codeline>
<codeline lineno="69"><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1gac8f26d8dfa22eaef5a39303409133dfc">mtb_bmi160_init_i2c</ref>(<ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref><sp />*obj,<sp />cyhal_i2c_t<sp />*inst,<sp /><ref kindref="member" refid="group__group__board__libs_1gaa1ef72a83807270481aaa556892729bd">mtb_bmi160_address_t</ref><sp />address)</highlight></codeline>
<codeline lineno="71"><highlight class="normal">{</highlight></codeline>
<codeline lineno="72"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(inst<sp />!=<sp />NULL);</highlight></codeline>
<codeline lineno="73"><highlight class="normal"><sp /><sp /><sp /><sp />i2c<sp />=<sp />inst;</highlight></codeline>
<codeline lineno="74"><highlight class="normal" /></codeline>
<codeline lineno="75"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />BMI160<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.id<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />address;</highlight></codeline>
<codeline lineno="77"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.interface<sp /><sp /><sp /><sp />=<sp />BMI160_I2C_INTF;</highlight></codeline>
<codeline lineno="78"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.read<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />(bmi160_com_fptr_t)i2c_read_bytes;</highlight></codeline>
<codeline lineno="79"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.write<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />(bmi160_com_fptr_t)i2c_write_bytes;</highlight></codeline>
<codeline lineno="80"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.delay_ms<sp /><sp /><sp /><sp /><sp />=<sp />delay_wrapper;</highlight></codeline>
<codeline lineno="81"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;intpin1<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />NC;</highlight></codeline>
<codeline lineno="82"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;intpin2<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />NC;</highlight></codeline>
<codeline lineno="83"><highlight class="normal" /></codeline>
<codeline lineno="84"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />BNI160<sp />sensor<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="85"><highlight class="normal"><sp /><sp /><sp /><sp />int8_t<sp />status<sp />=<sp />bmi160_init(&amp;(obj-&gt;sensor));</highlight></codeline>
<codeline lineno="86"><highlight class="normal" /></codeline>
<codeline lineno="87"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(BMI160_OK<sp />==<sp />status)<sp /></highlight><highlight class="comment">/*<sp />BMI160<sp />initialization<sp />successful<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="88"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />?<sp /><ref kindref="member" refid="group__group__board__libs_1gae39ac49787bfd21ab9c2b1ebdfe03fd8">mtb_bmi160_config_default</ref>(obj)</highlight></codeline>
<codeline lineno="89"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />:<sp />BMI160_ERROR(status);</highlight></codeline>
<codeline lineno="90"><highlight class="normal">}</highlight></codeline>
<codeline lineno="91"><highlight class="normal" /></codeline>
<codeline lineno="92"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1gae39ac49787bfd21ab9c2b1ebdfe03fd8">mtb_bmi160_config_default</ref>(<ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref><sp />*<sp />obj)</highlight></codeline>
<codeline lineno="93"><highlight class="normal">{</highlight></codeline>
<codeline lineno="94"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Select<sp />the<sp />Output<sp />data<sp />rate,<sp />range<sp />of<sp />accelerometer<sp />sensor<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="95"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.accel_cfg.odr<sp />=<sp />BMI160_ACCEL_ODR_1600HZ;</highlight></codeline>
<codeline lineno="96"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.accel_cfg.range<sp />=<sp />BMI160_ACCEL_RANGE_2G;</highlight></codeline>
<codeline lineno="97"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.accel_cfg.bw<sp />=<sp />BMI160_ACCEL_BW_NORMAL_AVG4;</highlight></codeline>
<codeline lineno="98"><highlight class="normal" /></codeline>
<codeline lineno="99"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Select<sp />the<sp />power<sp />mode<sp />of<sp />accelerometer<sp />sensor<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="100"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.accel_cfg.power<sp />=<sp />BMI160_ACCEL_NORMAL_MODE;</highlight></codeline>
<codeline lineno="101"><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Select<sp />the<sp />Output<sp />data<sp />rate,<sp />range<sp />of<sp />gyroscope<sp />sensor<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="103"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.gyro_cfg.odr<sp />=<sp />BMI160_GYRO_ODR_3200HZ;</highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.gyro_cfg.range<sp />=<sp />BMI160_GYRO_RANGE_2000_DPS;</highlight></codeline>
<codeline lineno="105"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.gyro_cfg.bw<sp />=<sp />BMI160_GYRO_BW_NORMAL_MODE;</highlight></codeline>
<codeline lineno="106"><highlight class="normal" /></codeline>
<codeline lineno="107"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Select<sp />the<sp />power<sp />mode<sp />of<sp />gyroscope<sp />sensor<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="108"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;sensor.gyro_cfg.power<sp />=<sp />BMI160_GYRO_NORMAL_MODE;</highlight></codeline>
<codeline lineno="109"><highlight class="normal" /></codeline>
<codeline lineno="110"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />sensor<sp />configuration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="111"><highlight class="normal"><sp /><sp /><sp /><sp />int8_t<sp />status<sp />=<sp />bmi160_set_sens_conf(&amp;(obj-&gt;sensor));</highlight></codeline>
<codeline lineno="112"><highlight class="normal" /></codeline>
<codeline lineno="113"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(BMI160_OK<sp />==<sp />status)</highlight></codeline>
<codeline lineno="114"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />?<sp />CY_RSLT_SUCCESS</highlight></codeline>
<codeline lineno="115"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />:<sp />BMI160_ERROR(status);</highlight></codeline>
<codeline lineno="116"><highlight class="normal">}</highlight></codeline>
<codeline lineno="117"><highlight class="normal" /></codeline>
<codeline lineno="118"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1ga6e259c8f5f575e06fc3d35c525b4038f">mtb_bmi160_read</ref>(<ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref><sp />*obj,<sp /><ref kindref="compound" refid="structmtb__bmi160__data__t">mtb_bmi160_data_t</ref><sp />*sensor_data)</highlight></codeline>
<codeline lineno="119"><highlight class="normal">{</highlight></codeline>
<codeline lineno="120"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />To<sp />read<sp />both<sp />Accel<sp />and<sp />Gyro<sp />data<sp />along<sp />with<sp />time*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="121"><highlight class="normal"><sp /><sp /><sp /><sp />int8_t<sp />status<sp />=<sp />bmi160_get_sensor_data((BMI160_ACCEL_SEL<sp />|<sp />BMI160_GYRO_SEL<sp />|<sp />BMI160_TIME_SEL),</highlight></codeline>
<codeline lineno="122"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;(sensor_data-&gt;<ref kindref="member" refid="structmtb__bmi160__data__t_1ad5ac1a5381c64919a50c422822b7b283">accel</ref>),<sp />&amp;(sensor_data-&gt;<ref kindref="member" refid="structmtb__bmi160__data__t_1a48802d2731e2f1f3722181451f4fafc7">gyro</ref>),<sp />&amp;(obj-&gt;sensor));</highlight></codeline>
<codeline lineno="123"><highlight class="normal" /></codeline>
<codeline lineno="124"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(BMI160_OK<sp />==<sp />status)</highlight></codeline>
<codeline lineno="125"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />?<sp />CY_RSLT_SUCCESS</highlight></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />:<sp />BMI160_ERROR(status);</highlight></codeline>
<codeline lineno="127"><highlight class="normal">}</highlight></codeline>
<codeline lineno="128"><highlight class="normal" /></codeline>
<codeline lineno="129"><highlight class="normal" /><highlight class="keyword">struct<sp /></highlight><highlight class="normal">bmi160_dev<sp />*<ref kindref="member" refid="group__group__board__libs_1ga5ea290e0ec118186d1c10b23edfaa98e">mtb_bmi160_get</ref>(<ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="130"><highlight class="normal">{</highlight></codeline>
<codeline lineno="131"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />&amp;(obj-&gt;sensor);</highlight></codeline>
<codeline lineno="132"><highlight class="normal">}</highlight></codeline>
<codeline lineno="133"><highlight class="normal" /></codeline>
<codeline lineno="134"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1gacf88df809c21de6db3fa1b24ba1044f2">mtb_bmi160_selftest</ref>(<ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="135"><highlight class="normal">{</highlight></codeline>
<codeline lineno="136"><highlight class="normal"><sp /><sp /><sp /><sp />int8_t<sp />status<sp />=<sp />bmi160_perform_self_test(BMI160_ACCEL_SEL,<sp />&amp;(obj-&gt;sensor));</highlight></codeline>
<codeline lineno="137"><highlight class="normal" /></codeline>
<codeline lineno="138"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(status<sp />==<sp />BMI160_OK)</highlight></codeline>
<codeline lineno="139"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="140"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />status<sp />=<sp />bmi160_perform_self_test(BMI160_GYRO_SEL,<sp />&amp;(obj-&gt;sensor));</highlight></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="142"><highlight class="normal" /></codeline>
<codeline lineno="143"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(BMI160_OK<sp />==<sp />status)</highlight></codeline>
<codeline lineno="144"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />?<sp />CY_RSLT_SUCCESS</highlight></codeline>
<codeline lineno="145"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />:<sp />BMI160_ERROR(status);</highlight></codeline>
<codeline lineno="146"><highlight class="normal">}</highlight></codeline>
<codeline lineno="147"><highlight class="normal" /></codeline>
<codeline lineno="148"><highlight class="normal">cy_rslt_t<sp />_mtb_bmi160_config_int(cyhal_gpio_t<sp />*intpin,<sp />cyhal_gpio_t<sp />pin,<sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />init,<sp />uint8_t<sp />intr_priority,<sp />cyhal_gpio_event_t<sp />event,<sp />cyhal_gpio_event_callback_t<sp />callback,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg)</highlight></codeline>
<codeline lineno="149"><highlight class="normal">{</highlight></codeline>
<codeline lineno="150"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result<sp />=<sp />CY_RSLT_SUCCESS;</highlight></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="152"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(NULL<sp />==<sp />callback)</highlight></codeline>
<codeline lineno="153"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="154"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_gpio_free(pin);</highlight></codeline>
<codeline lineno="155"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*intpin<sp />=<sp />NC;</highlight></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="157"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="158"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="159"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(init)</highlight></codeline>
<codeline lineno="160"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="161"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />cyhal_gpio_init(pin,<sp />CYHAL_GPIO_DIR_INPUT,<sp />CYHAL_GPIO_DRIVE_NONE,<sp />0);</highlight></codeline>
<codeline lineno="162"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="163"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_RSLT_SUCCESS<sp />==<sp />result)</highlight></codeline>
<codeline lineno="164"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*intpin<sp />=<sp />pin;</highlight></codeline>
<codeline lineno="166"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_gpio_register_callback(pin,<sp />callback,<sp />callback_arg);</highlight></codeline>
<codeline lineno="167"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_gpio_enable_event(pin,<sp />event,<sp />intr_priority,<sp />1);</highlight></codeline>
<codeline lineno="168"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="169"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="170"><highlight class="normal" /></codeline>
<codeline lineno="171"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="172"><highlight class="normal">}</highlight></codeline>
<codeline lineno="173"><highlight class="normal" /></codeline>
<codeline lineno="174"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1gae3faebe4fcb363ab41d2f79a297ddf66">mtb_bmi160_config_int</ref>(<ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref><sp />*obj,<sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp />bmi160_int_settg<sp />*intsettings,<sp />cyhal_gpio_t<sp />pin,<sp />uint8_t<sp />intr_priority,<sp />cyhal_gpio_event_t<sp />event,<sp />cyhal_gpio_event_callback_t<sp />callback,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg)</highlight></codeline>
<codeline lineno="175"><highlight class="normal">{</highlight></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result;</highlight></codeline>
<codeline lineno="177"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="178"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(obj-&gt;intpin1<sp />==<sp />pin)</highlight></codeline>
<codeline lineno="179"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="180"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />_mtb_bmi160_config_int(&amp;(obj-&gt;intpin1),<sp />pin,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,<sp />intr_priority,<sp />event,<sp />callback,<sp />callback_arg);</highlight></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="182"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(obj-&gt;intpin2<sp />==<sp />pin)</highlight></codeline>
<codeline lineno="183"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="184"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />_mtb_bmi160_config_int(&amp;(obj-&gt;intpin2),<sp />pin,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,<sp />intr_priority,<sp />event,<sp />callback,<sp />callback_arg);</highlight></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="186"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(obj-&gt;intpin1<sp />==<sp />NC)</highlight></codeline>
<codeline lineno="187"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="188"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />_mtb_bmi160_config_int(&amp;(obj-&gt;intpin1),<sp />pin,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,<sp />intr_priority,<sp />event,<sp />callback,<sp />callback_arg);</highlight></codeline>
<codeline lineno="189"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="190"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(obj-&gt;intpin2<sp />==<sp />NC)</highlight></codeline>
<codeline lineno="191"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="192"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />_mtb_bmi160_config_int(&amp;(obj-&gt;intpin2),<sp />pin,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,<sp />intr_priority,<sp />event,<sp />callback,<sp />callback_arg);</highlight></codeline>
<codeline lineno="193"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="194"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="195"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="196"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__board__libs_1ga6a782574f531667dbb853ad8e068cda8">CYHAL_BMI160_RSLT_ERR_ADDITIONAL_INT_PIN</ref>;</highlight></codeline>
<codeline lineno="197"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="198"><highlight class="normal" /></codeline>
<codeline lineno="199"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(result<sp />==<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="200"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="201"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />int8_t<sp />status<sp />=<sp />bmi160_set_int_config(intsettings,<sp />&amp;(obj-&gt;sensor));</highlight></codeline>
<codeline lineno="202"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(status<sp />!=<sp />BMI160_OK)<sp />result<sp />=<sp />BMI160_ERROR(status);</highlight></codeline>
<codeline lineno="203"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="204"><highlight class="normal" /></codeline>
<codeline lineno="205"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="206"><highlight class="normal">}</highlight></codeline>
<codeline lineno="207"><highlight class="normal" /></codeline>
<codeline lineno="208"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__board__libs_1ga8c47f76e2339fd3a4b50d7c8c1462003">mtb_bmi160_free</ref>(<ref kindref="compound" refid="structmtb__bmi160__t">mtb_bmi160_t</ref><sp />*<sp />obj)</highlight></codeline>
<codeline lineno="209"><highlight class="normal">{</highlight></codeline>
<codeline lineno="210"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(obj-&gt;intpin1<sp />!=<sp />NC)</highlight></codeline>
<codeline lineno="211"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="212"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_gpio_free(obj-&gt;intpin1);</highlight></codeline>
<codeline lineno="213"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="214"><highlight class="normal" /></codeline>
<codeline lineno="215"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(obj-&gt;intpin2<sp />!=<sp />NC)</highlight></codeline>
<codeline lineno="216"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="217"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_gpio_free(obj-&gt;intpin2);</highlight></codeline>
<codeline lineno="218"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="219"><highlight class="normal" /></codeline>
<codeline lineno="220"><highlight class="normal"><sp /><sp /><sp /><sp />i2c<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="221"><highlight class="normal">}</highlight></codeline>
<codeline lineno="222"><highlight class="normal" /></codeline>
<codeline lineno="223"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="224"><highlight class="normal">}</highlight></codeline>
<codeline lineno="225"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_BMI160/sensor-motion-bmi160/mtb_bmi160.c" />
  </compounddef>
</doxygen>